/*================================================================================================*
 * Переход от USB bulk к вводу-выводу байтов (с кольцевыми буферами)
 *================================================================================================*/

#ifndef USB_BULK_H_
#define USB_BULK_H_

#include "global.h"
#include "lusb.h"

/*================================================================================================*/
/* Настройка буферов */
#if 1
/* буферы в SDRAM, большие */
#define USBBULK_TX_BLOCK_LEN        1024
#define USBBULK_TX_BUF_NBLK         LUSB_DMA_EP_DESCR_CNT
#define USBBULK_RX_BLOCK_LEN        512
#define USBBULK_RX_BUF_NBLK         LUSB_DMA_EP_DESCR_CNT
#define USBBULK_BUF_DECL            __attribute__ ((section(".sdram")))
#else
/* буферы в SRAM -- похоже, не дают выигрыша, но хуже работают, потому что мало */
#define USBBULK_TX_BLOCK_LEN        512
#define USBBULK_TX_BUF_NBLK         16
#define USBBULK_RX_BLOCK_LEN        512
#define USBBULK_RX_BUF_NBLK         16
#define USBBULK_BUF_DECL            __attribute__ ((section(".bss3")))
#endif

/* Биты глобальной переменной g_usbbulk_flags */
#define USBBULK_FLAG_PARTIAL_SEND   0x01    /* Разрешить неполную передачу usbbulk_send */

/* Выбор способа копирования данных (memcpy или цикл) */
#define USBBULK_TX_USE_MEMCPY       1
#define USBBULK_RX_USE_MEMCPY       1

/* Хак для борьбы с потерей первого пакета при глючной очистке DMA (баг LPC??)
   Верхний уровень должен уметь отбрасывать пакет нулевой длины без ошибки */
#define USBBULK_CLEARDMA_HACK       0
/*================================================================================================*/

/*================================================================================================*/
extern uint8_t g_usbbulk_flags;
/*================================================================================================*/

/*================================================================================================*/
/*------------------------------------------------------------------------------------------------*/
/* Инициализация */
void usbbulk_init(void);
/*------------------------------------------------------------------------------------------------*/
/* Сброс и повторная инициализация */
void usbbulk_reset(void);
/*------------------------------------------------------------------------------------------------*/
/* Вычисление свободного места в буфере передачи (сколько байт можно отправить прямо сейчас) */
size_t usbbulk_send_buf_avail(void);
/*------------------------------------------------------------------------------------------------*/
/* Запись данных в буфер передачи USB */
size_t usbbulk_send
    (
    const uint8_t* data,            /* Данные */
    size_t len,                     /* Размер данных в байтах */
    int push                        /* 1 = отправить сразу даже неполный блок */
    );                              /* Возвращает количество отправленных байт */
/*------------------------------------------------------------------------------------------------*/
/* Чтение данных из буфера приема USB */
size_t usbbulk_recv
    (
    uint8_t* data,                  /* Буфер для данных */
    size_t len                      /* Размер в байтах (максимальный) */
    );                              /* Возвращает количество прочитанных байт (0..len) */
/*------------------------------------------------------------------------------------------------*/
/* Фоновая функция */
void usbbulk_worker(void);
/*------------------------------------------------------------------------------------------------*/
/*================================================================================================*/
#endif /* USB_BULK_H_ */
